import { Input } from './input';
import { Output } from './output';
import { Connection } from './connection';
import { Control } from './control';
export declare class Node {
    name: string;
    static latestId: number;
    guid: string;
    id: number;
    data: Map<string, unknown>;
    inputs: Map<string, Input>;
    outputs: Map<string, Output>;
    controls: Map<string, Control>;
    position: [number, number];
    constructor(name: string);
    static nextId(): number;
    static resetId(): void;
    private add;
    addControl(control: Control): this;
    removeControl(control: Control): void;
    addInput(input: Input): this;
    removeInput(input: Input): void;
    addOutput(output: Output): this;
    removeOutput(output: Output): void;
    getConnections(): Connection[];
}
